stages:
- build
- test

compile:
  stage: build
  image: maven:3.8.6-openjdk-8-slim
  script:
    - mvn clean package
  artifacts:
      paths:
      - target/
      expire_in: 1 hour

sonar-scanner-cloud:
  stage: test
  variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  needs:
    - compile
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_PROJECT_NAME}-sonar"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner
      -Dsonar.qualitygate.wait=true 
      -Dsonar.projectName=${CI_PROJECT_NAME} 
      -Dsonar.projectKey=${CI_PROJECT_NAME} 
      -Dsonar.branch.name=${CI_COMMIT_BRANCH}
      -Dsonar.projectKey=${SONAR_ORGANIZATION}_${CI_PROJECT_NAME} 
      -Dsonar.organization=${SONAR_ORGANIZATION}
      -Dsonar.sources=src/main/java/
      -Dsonar.language=java
      -Dsonar.java.binaries:**/target/classes
  only:
    - master
